<?php
require 'renderer.php';

class Mailhandling extends Renderer {
    
    public function __construct() {
        parent::__construct();
        if (!$this->connectToImap($this->folder)) {
            $this->templateName = 'imaperror';
            return;
        }
    }
    
    protected function fetchEmail(): PhpImap\IncomingMail {
        $mailsIds = $this->mbox->searchMailbox($this->folder);
        if (!in_array($this->uid, $mailsIds)) {
            echo 'nicht auffindbar';
            var_dump($this->folder, $this->uid);
            die;
        }
        $mail = $this->mbox->getMail($this->uid);
        return $mail;
    }
    
    protected function getAttachments($structure): array {
        $attachments = [];
        if(isset($structure->parts) && count($structure->parts)) {
            for($i = 0; $i < count($structure->parts); $i++) {
                $attachments[$i] = [
                    'is_attachment' => false,
                    'filename' => '',
                    'name' => '',
                    'attachment' => ''];

                if($structure->parts[$i]->ifdparameters) {
                    foreach($structure->parts[$i]->dparameters as $object) {
                        if(strtolower($object->attribute) == 'filename') {
                            $attachments[$i]['is_attachment'] = true;
                            $attachments[$i]['filename'] = $object->value;
                        }
                    }
                }

                if($structure->parts[$i]->ifparameters) {
                    foreach($structure->parts[$i]->parameters as $object) {
                        if(strtolower($object->attribute) == 'name') {
                            $attachments[$i]['is_attachment'] = true;
                            $attachments[$i]['name'] = $object->value;
                        }
                    }
                }

                if($attachments[$i]['is_attachment']) {
                    $attachments[$i]['attachment'] = imap_fetchbody($this->mbox, $this->uid, $i+1);
                    if($structure->parts[$i]->encoding == 3) { // 3 = BASE64
                        $attachments[$i]['attachment'] = base64_decode($attachments[$i]['attachment']);
                    }
                    elseif($structure->parts[$i]->encoding == 4) { // 4 = QUOTED-PRINTABLE
                        $attachments[$i]['attachment'] = quoted_printable_decode($attachments[$i]['attachment']);
                    }
                }
                if ($attachments[$i]['is_attachment']) {
                }
            }
        }
        $realAttachments = array_filter($attachments, function($attachment) {
            return $attachment['is_attachment'];
        });
        return $realAttachments;
    }
}
